/* GCNcrypt - Gamecube AR Crypto Program
 *
 * Copyright notice for this file:
 *  Copyright (C) 2003-2004 Parasyte
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _COMMON_H_
#define _COMMON_H_


#include "types.h"

void generateseeds(u32 *seeds, const u8 *seedtable, u8 doreverse);
u32 rotate_left(u32 value, u8 rotate);
u32 rotate_right(u32 value, u8 rotate);
u32 byteswap(u32 val);
void getcode(u32 *src, u32 *addr, u32 *val);
void setcode(u32 *dst, u32 addr, u32 val);
u16 gencrc16(u32 *codes, u16 size);
u8 verifycode(u32 *codes, u16 size);
void buildseeds();

#endif //_COMMON_H_
